var g_gpshelper = null; // Contains information about the users position if available.  Watch must be called before it's usable

function toRad(valuein)
{
   return valuein * Math.PI / 180;
}

function GpsHelper()
{
	var m_current_position;
	var m_accuracy;
	var m_watch_id;
	var m_has_received_gps;
	
	this.m_current_position = new Vector2Double( 0, 0 );	
	this.m_accuracy = 0;
	this.m_has_received_gps = false;
	this.m_watch_id = null;
	
	this.enable_watch = function()
	{
		this.m_has_received_gps = false;
		// Get the first position if we can
		/*
		navigator.geolocation.getCurrentPosition(this.update_position, 
			function showError(error) 
			{
				var text = "";
				switch(error.code) 
				{
					case error.PERMISSION_DENIED:
						text = "User denied the request for Geolocation."
						break;
					case error.POSITION_UNAVAILABLE:
						text = "Location information is unavailable."
						break;
					case error.TIMEOUT:
						text = "The request to get user location timed out."
						break;
					case error.UNKNOWN_ERROR:
						text = "An unknown error occurred."
						break;
				}
				text = "Error on getCurrentPosition:"+text;
				g_gpshelper.show_debug_text();
				dalert( text );
			}
		);
*/
		// register for any updates
		var options = { timeout: 60000, enableHighAccuracy: true };
        this.m_watch_id = navigator.geolocation.watchPosition(this.on_update_success, this.on_update_error, options);
		this.show_debug_text("enabled gps");
	}
	
	this.disable_watch = function()
	{
		if( g_gpshelper.m_watch_id != null )
		{
			g_gpshelper.m_has_received_gps = false;

			navigator.geolocation.clearWatch(g_gpshelper.m_watch_id);
			g_gpshelper.m_watch_id = null;
			this.show_debug_text("disabled gps");
		}
		else
		{
			dalert( 'clearing GPS updates when not enabled' );
		}
	}
	
	this.on_update_success = function(position) 
	{
		g_gpshelper.update_position(position);
	}
	
	this.update_position = function(position)
	{
		g_gpshelper.m_has_received_gps = true;

		if( ( g_gpshelper != null ) && ( position != null ) )
		{
			g_gpshelper.set_user_location( position.coords.longitude, position.coords.latitude, position.coords.accuracy );
			g_gpshelper.show_debug_text( 'Latitude: '  + position.coords.latitude      + '<br />' +
								  'Longitude: ' + position.coords.longitude     + '<br />');
		}
		else{
			if( position != null )
			{
				g_gpshelper.show_debug_text( 'gpshelper is null');
			}
			else
			{
				g_gpshelper.show_debug_text( 'position is null');
			}
		}
		
		// Fire an event so any pages listening know to update their contents
		// Store the location of the search so we can generate summary heat maps to select best venue locations whilst ensuring the data remains anonymous
		FlurryAgent.setLocation(position.coords.latitude, position.coords.longitude, position.coords.accuracy);
		$(document).trigger( "gps_updated" );
	}
	
	this.show_debug_text = function( html )
	{
		if( m_debug_view_gps_locations_text )
		{
			var element = document.getElementById('version_text');
			var d = new Date();
			var timestamp = d.getTime()/1000;
			var enabled = "false";
			if( g_gpshelper.m_watch_id != null )
			{
				enabled = "true";
			}
			element.innerHTML = html + "<br/>Enabled:"+enabled+"<br/>Updated:"+timestamp;
		}		
	}

	this.on_update_error = function(error) 
	{
		dalert('code: '    + error.code    + '\n' +
			  'message: ' + error.message + '\n');
		g_gpshelper.show_debug_text( 'code: '    + error.code    + '<br/>' +
								'message: ' + error.message + '<br />');
			  
	}		


	this.get_distance_in_km = function( lon1, lat1, lon2, lat2 )
	{
		var R = 6371; // km 

		var x1 = lat2-lat1;
		var dLat = toRad(x1);
		var x2 = lon2-lon1;
		var dLon = toRad(x2);
		var a = Math.sin(dLat/2) * Math.sin(dLat/2) + 
						Math.cos(toRad(lat1)) * Math.cos(toRad(lat2)) *
						Math.sin(dLon/2) * Math.sin(dLon/2);  
		var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a)); 
		var d = R * c;
		return d;
	}	
	
	
	this.set_user_location= function(longitude, latitude, accuracy)
	{
		this.m_current_position = new Vector2Double( longitude,latitude );
		this.m_accuracy = accuracy;
	}
	
	this.get_user_location = function()
	{
		return this.m_current_position;
	}
	
	this.get_distance_from_user_as_meters = function(longitude,latitude)
	{	
		var distance_in_meters = this.get_distance_in_km( this.m_current_position.m_x,  this.m_current_position.m_y, longitude, latitude ) * 1000;
		
		distance_in_meters = Math.floor( distance_in_meters / 50) * 50;
		if( distance_in_meters > 500 )
		{
			distance_in_meters = Math.floor( distance_in_meters / 100) * 100;
		}
		return distance_in_meters;
	}
	
	this.get_distance_from_user_as_meters_or_km = function(longitude,latitude, prepend_text, html_if_no_user_location, max_distance_range_in_meters)
	{	
		if( ( typeof( longitude ) == 'undefined' ) ||( typeof( latitude ) == 'undefined' ) )
		{
			return html_if_no_user_location;
		}
		var distance_in_meters = this.get_distance_from_user_as_meters(longitude,latitude);
		if( isNaN(distance_in_meters) )
		{
			return html_if_no_user_location;
		}
		if( this.m_has_received_gps == false )
		{
			return html_if_no_user_location;
		}
		if( max_distance_range_in_meters != null )
		{
			if( distance_in_meters > max_distance_range_in_meters )
			{
				return html_if_no_user_location;
			}
		}
		
		var value = distance_in_meters + " meters";
		if( distance_in_meters > 950 )
		{
			value = (distance_in_meters / 1000)+" km";
		}
		return prepend_text + value;
	}
	this.get_distance_from_user_as_time_to_walk = function(longitude,latitude)
	{	
		var distance_in_meters = this.get_distance_from_user_as_meters(longitude,latitude);
		
		// Average walking speed is about 4kph
		var time_in_hours = ((distance_in_meters / 1000) / 4);
		if( time_in_hours > 2 )
		{
			return "Over 2 hours away to walk";
		}
		
		if( time_in_hours > 1 )
		{
			time_in_hours = Math.floor( time_in_hours * 10 ) / 10;
			return "" + time_in_hours + " hours away by walking";
		}
		var time_in_minutes = Math.floor( time_in_hours * 60 / 5) * 5;
		return "" + time_in_minutes + " minutes away by walking";
	
	}
	
}