
function Vector2Double(x,y)
{
	var m_x;
	var m_y;
	if( x != null )
	{
		if( typeof(x) === 'object')
		{
			this.m_x = x.m_x;
			this.m_y = x.m_y;
		}
		else
		{
			this.m_x = x;
			this.m_y = y;
		}
	}
	else
	{
		this.m_x = 0;
		this.m_y = 0;
	}
	// X1*X2 + Y1*Y2
	this.dot = function( x, y )
	{
		if( typeof(x) === 'object')
		{
			return this.dot( x.m_x, x.m_y);
		}
		else
		{
			return (this.m_x * x) + (this.m_y * y);
		}
	}
	
	this.add = function(vecA)
	{
		this.m_x += vecA.m_x;
		this.m_y += vecA.m_y;
	}

	this.subtract = function(vecA)
	{
		this.m_x -= vecA.m_x;
		this.m_y -= vecA.m_y;
	}

	this.length = function()
	{
		var length = Math.sqrt(this.m_x * this.m_x + this.m_y * this.m_y );
		return length;
	}
	this.normalize = function()
	{
		var length = this.length();
		if( length <= 0 )
		{
			length = 1;
		}
		
		this.m_x /= length;
		this.m_y /= length;
	}

	this.multiply = function(value)
	{
		this.m_x *= value;
		this.m_y *= value;
	}
	
	
}

// ------------------------------------------
// Static methods
Vector2Double.test = function()
{
	var vecAB = new Vector2Double( 3,4 );
	var vecCD = new Vector2Double( 7,10 );
	var vecEF = new Vector2Double( vecAB );
	
	alert( 'vecEF length:'+vecEF.length() );
	
	vecAB.add( vecCD );
	alert( 'vecAB + vecCD = X:'+vecAB.m_x+' Y:'+vecAB.m_y );
	
	vecAB.subtract( vecCD );
	alert( 'vecAB - vecCD = X:'+vecAB.m_x+' Y:'+vecAB.m_y );

	vecAB.multiply( 2 );
	alert( 'vecAB x 2 = X:'+vecAB.m_x+' Y:'+vecAB.m_y );

	vecAB.normalize();
	alert( 'vecAB normalised = X:'+vecAB.m_x+' Y:'+vecAB.m_y );
	alert( 'vecAB normalised length = X:'+vecAB.length() );	
}
