// Returns array {r,g,b} values of 0-255
function colours_hex_string_to_rgb(hex) 
{
    var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
    return result ? {
        r: parseInt(result[1], 16),
        g: parseInt(result[2], 16),
        b: parseInt(result[3], 16)
    } : null;
}

// Returns #332053
function colours_rgb_to_hex_string( rgb ) 
{
	var r = rgb.r;
	var g = rgb.g;
	var b = rgb.b;
	
	if( r > 255 )
	{
		r = 255;
	} else if( r < 0 )
	{
		r = 0;
	}

	if( g > 255 )
	{
		g = 255;
	} else if( g < 0 )
	{
		g = 0;
	}
	if( b > 255 )
	{
		b = 255;
	} else if( b < 0 )
	{
		b = 0;
	}
	
    return "#" + ((1 << 24) + (r << 16) + (g << 8) + b).toString(16).slice(1);
}

function colours_mix( rgb1, rgb2, alpha )
{
	var beta = 1.0 - alpha;
	var rgbout = [];
	rgbout.r = Math.floor( ( parseInt(rgb1.r,10) * alpha ) + ( parseInt(rgb2.r,10) * beta ));
	rgbout.g = Math.floor( ( parseInt(rgb1.g,10) * alpha ) + ( parseInt(rgb2.g,10) * beta ));
	rgbout.b = Math.floor( ( parseInt(rgb1.b,10) * alpha ) + ( parseInt(rgb2.b,10) * beta ));
	return rgbout;
}

function colour_black_or_white_for_colour_string( track_colour_string )
{
	var array_colour_temp1 = colours_hex_string_to_rgb( track_colour_string );
	var text_colour = "#FFFFFF";
	// If the background is too bright, swap to black text
	if( ( ( array_colour_temp1.r * 0.3 ) + ( array_colour_temp1.g * 0.6 ) + ( array_colour_temp1.b * 0.1 ) ) > (0.65 * 255) ) 
	{
		text_colour = "#000000";
	}
	return text_colour;
}
