var m_local_file_path = "";


function get_local_path_for_htmlelement( callback )
{
	// If this is an app use local filestore
	if( !m_is_website )
	{
		var device_platform = 'Web';
		if( typeof( device ) != 'undefined' )
		{
			device_platform = device.platform;
		}
		
		if( is_wp8() )
		{
			// To read images downloaded we just do "/somedirectory/myimage.jpg"
			var path = "/" + get_local_file_subdirectory_for_event()+"/";
			if( typeof( g_debug_showpathsused ) != 'undefined' )
			{
				//alert( 'SR:In WP8:'+path );
			}
			callback( path );
		}
		else
		{
			// Every other platform we use the toURL root.
			if( typeof window.requestFileSystem != 'undefined' )
			{
				window.requestFileSystem(LocalFileSystem.PERSISTENT, 0,
					function onFileSystemSuccess(fileSystem)
					{
						//var path = fileSystem.root.toURL()+ get_local_file_subdirectory_for_event() + "/";
						var path = fileSystem.root.toURL()+ get_local_file_subdirectory_for_event() + "/";
						
						// Android fix.  On Samsung I found it was searching file:///sortage/sdcard0/triangulate/14 
						// but the HTML will only load an image from here    file://storage/sdcard/triangulate/14/labourtest.png
						path = path.replace("file:///sortage/sdcard0/", "file://storage/sdcard/");

						//path = path.replace( /x-wmapp0:\/\//, "" );
						
						callback(path);
					}
				);
			
			}
			else
			{
				derror('window.requestFileSystem not defined');
			}
		}
	}
	else
	{
		// Just get the main fileCreatedDate
		var path = g_url_remote_file_location + g_event_id + "/";
		
		callback(path);
		
	}
}

// Should be in file.js
function get_local_path( callback )
{
	if( isPhoneGap() )
	{
		var extension = get_local_file_subdirectory_for_event();
		// iOS/Android
		m_local_file_path = "cdvfile://localhost/persistent/"+extension+"/";
	}
	else
	{
		m_local_file_path = "SR:NOTPHONEGAP";
	}
	//m_local_file_path is already set no need to set
	callback( m_local_file_path );
}


// Gets just the extension part of the filename for the current event.  e.g. "triangulate/14"
function get_local_file_subdirectory_for_event()
{
	return "triangulate/"+g_event_id;
}




// read the file that has been download
function readFile(nameOfFile, on_success, on_error)
{
	get_local_path( 
		function( local_file_path )
		{
			window.requestFileSystem(window.LocalFileSystem.PERSISTENT, 0,
				function(fileSystem)
				{
					local_file_path = get_local_file_subdirectory_for_event();
					fileSystem.root.getDirectory(local_file_path, {create: false}, 
						function founddirectory(directorySystem)
						{
							//var path_with_file = local_file_path + nameOfFile;
					//alert('Looking in directory'+local_file_path + ": :"+nameOfFile+":");
							directorySystem.getFile( nameOfFile,
								{
									create: false,
									exclusive: false
								},
								function success_filefound(fileEntry)
								{
									fileEntry.file(
										function(file)
										{
											var reader = new window.FileReader();
											reader.onloadend = function(evt)
												{
//		alert('Yes loaded downloaded file');
													on_success(evt.target.result);
												};
											reader.onerror = function(evt)
												{
													dalert(evt.target.result);
													on_error(nameOfFile);
												};
											reader.readAsText(file);
										},
										function error_unabletoreadfile(e)
										{
											// UNKNOWN? Couldn't read it
											dalert("File:"+e.message);
											on_error(nameOfFile);
										}
									);
								},
								function error_nofilefound(e)
								{
									// Probably file not found
									on_error(nameOfFile);
								}
							);
						},
						function error_nodirectory(e)
						{
							// No local file system
							on_error(nameOfFile);
						}
					);
				}
			);
		}
	);
}


function diskutils_stop_icloud_backups_being_saved()
{
	try
	{
		setFolderMetadata(LocalFileSystem.PERSISTENT, "Backups", "com.apple.MobileBackup", 1);
	}
	catch(e)
	{
		//dalert('Metadata not set for Backups');
	}
}

function setFolderMetadata(localFileSystem, subFolder, metadataKey, metadataValue) 
{
	// This is only applicable for iOS devices
	if( device.platform == "iPhone" )
	{

	var onSetMetadataWin = function() {
	    console.log("success setting metadata")
	}
	var onSetMetadataFail = function() {
	    console.log("error setting metadata")
	}
	
	var onGetDirectoryWin = function(parent) {
	    parent.setMetadata(onSetMetadataWin, onSetMetadataFail, { metadataKey: metadataValue});
	}
	var onGetDirectoryFail = function() {
	    console.log("error getting dir")
	}
	
	var onFSWin = function(fileSystem) {
	    fileSystem.root.getDirectory(subFolder, {create: true, exclusive: false}, onGetDirectoryWin, onGetDirectoryFail);
	}
	
	var onFSFail = function(evt) {
		console.log(evt.target.error.code);
	}

	window.requestFileSystem(localFileSystem, 0, onFSWin, onFSFail);
	}
	else
	{
		//alert( "In Not on IOS");
	}
}

