//EventDate
var m_timezone_offset_in_seconds = 0 * (60 * 60);
var m_reg_search_minus_exp = new RegExp("-", 'g');
var m_local_offset_seconds = (new Date().getTimezoneOffset()) * 60;

var EventDate =
{
	get_event_time_text : function( epochtimein, format )
		{		
			var epochtime = parseInt( epochtimein, 10 );
			if( epochtime > 0 )
			{
				var date_start = new Date(0); // The 0 there is the key, which sets the date to the epoch
				var local_offset_seconds = (new Date().getTimezoneOffset()) * 60;
				
				//alert( "epoch:"+epochtime+"\nevent offset:"+m_timezone_offset_in_seconds+"\nlocal offset:"+local_offset_seconds );
				date_start.setUTCSeconds(epochtime + m_timezone_offset_in_seconds + local_offset_seconds);

				return date_start.format(format);
			}
			return "";
		},
	set_event_timezone_for_event : function()
	{
		if( db != null )
		{
		db.transaction(
			function (tx) 
			{
				tx.executeSql("SELECT timezone_offset_in_hours FROM events WHERE id_event = "+g_event_id+" LIMIT 1", [], 
					function (tx, results) 
					{
						var len = results.rows.length;
						
						if( len == 1 )
						{
							var item = results.rows.item(0);
							m_timezone_offset_in_seconds = Math.floor( item['timezone_offset_in_hours'] * 60 * 60 );
							if( isNaN( m_timezone_offset_in_seconds ) )
							{
								m_timezone_offset_in_seconds = 0;
								dalert( 'Timezone has not been set for this event!' );
							}
							dalert( "Event timezone set to :"+m_timezone_offset_in_seconds );
						}
						else
						{
							dalert( "Could not find timezone from events" );
						}
					}, 
					null				
				);				
			}
		);
		}
		else
		{
			m_timezone_offset_in_seconds = 0;
			dalert('Timezone could not be set yet as db does not exist');
		}
	},
	get_event_timezone_offset_in_seconds : function()
	{
		return m_timezone_offset_in_seconds;
	},
	convert_datestring_to_timestamp : function(datestring)
	{
		var utc = parseInt(datestring,10);
		try
		{
			if( utc < 10000 )
			{
				// This is probably in the format 2014-09-24 14:15:00 
				var datewithcommas = datestring.replace(m_reg_search_minus_exp, "/");
				var jsdate = new Date(datewithcommas);
				utc = jsdate.getTime() / 1000;
			
				utc = utc - m_timezone_offset_in_seconds - m_local_offset_seconds;
			}
			else
			{
				//dalert( "date not parsed as probably already in UTC format:"+utc );
			}
		}
		catch(e)
		{
				// Invaliid date found
			console.log( "Invalid date found:"+datestring );
		}
		return utc;
	}
};