
var Favourites = 
{
	m_time_before_for_alert_in_seconds : (g_reminders_before_in_mins * 60),
	// To be called when all a sync has taken places, also can clears all notifications
	resetAllNotification : function ()
	{
     	// un comment to clear all notifications
		LocalNotifications.ClearAllNotifications();
		if( m_debug_local_notifications_via_alerts )
		{
			alert( 'setting alarms' );
		}
		Favourites._set_for_agendaitems_andfringes();
		// Favourites._set_for_fringeitems();  // This is actually called in above
	},

		// TODO: Order by start date so that we only worry about the next 64 items.
	_set_for_agendaitems_andfringes: function()
	{
		Favourites._set_for_items( "SELECT id_agendaitem as item_id, title as title, date_start as date_start, 'Main Hall' as venue_name FROM favourites LEFT JOIN agendaitems ON agendaitem_id = agendaitems.id_agendaitem", "timetable.html?agendaitem_id=", Favourites._set_for_fringeitems );
	},
	_set_for_fringeitems: function()
	{
		Favourites._set_for_items( "SELECT id_fringe as item_id, title as title, date_start as date_start, gpslocation.name as venue_name FROM favourites LEFT JOIN fringes ON fringe_id = fringes.id_fringe LEFT JOIN gpslocation ON fringes.gpslocation_id = gpslocation.id_gpslocation", "fringe_info.html?fringe_id=", null );
	},
	
	_set_for_items: function (sql3, pagelink, on_completed)
	{

		if( m_debug_local_notifications_via_alerts )
		{
			alert( 'using sql:'+sql3 );
		}
		db.transaction
		(
			function (tx) 
			{
				Favourites._create_table_if_not_exist(tx);
				
				tx.executeSql
				(
					sql3, 
					[], 
					function onsuccess(tx, results)
					{
						var len = results.rows.length;
						if( m_debug_local_notifications_via_alerts )
						{
							alert("Found this many favourites:"+len);
						}
						
						for( var i=0;i<len;i++)
						{
							var item = results.rows.item(i);
							var item_id = item['item_id'];
							if( item_id > 0 )
							{
								var date_start = parseInt(item['date_start'],10);
								//var description = item['title'] + "\n" + EventDate.get_event_time_text( item['date_start'], "DDDD DS, h:mm TT" + "\nLocation:"+item['venue_name']);
								var description = item['title'] + "\n" + EventDate.get_event_time_text( item['date_start'], "DDDD DS, h:mm TT" )+ "\nLocation:"+item['venue_name'];
								
								//alert("date is "+date_start);
								//alert("description "+description);
								// var now              = new Date().getTime(),
								// epochtime = now + 10 * 1000;

								var epochtime = date_start - Favourites.m_time_before_for_alert_in_seconds;
								if( m_debug_local_notifications_via_alerts )
								{
									alert("Adding reminder: item:"+item['item_id']+" description:"+description+" for time:"+epochtime );
								}

								var fullpagelink = pagelink + item['item_id'];
								LocalNotifications.AddNotification( item['item_id'], "Reminder", description, epochtime, fullpagelink  );
							}
						}
						// Chain next item set
						if( on_completed != null )
						{
							on_completed();
						}
					},
					function onfail(err)
					{
						dalert( "reset notifications failed:"+err.message+" For "+sql3);
					}
				);
			}      
		); //end of db transaction
	},

	
	_create_table_if_not_exist : function( tx )
	{
		if( !m_use_webserver_sql )
		{
			tx.executeSql('CREATE TABLE IF NOT EXISTS favourites (id unique, fringe_id, agendaitem_id, gpslocation_id, exhibitor_id)',[],
				function onsuccess(){}, 
				function onfailed(err)
				{ 
					dalert("Failed to create:"+err.message );
				} 
			);
		}
	},


	// adds agenda to favourites and make a notification
	addAgendaItemToFavourites : function (agendaitem_id, callback)
	{
		var eventParameters={};
		eventParameters['agendaitem_id'] = agendaitem_id.toString();
		FlurryAgent.logEvent("favourite_add_agendaitem", eventParameters); 

		Favourites._addItemToFavourites(agendaitem_id, callback, "agendaitem_id");
	},
	// adds agenda to favourites and make a notification
	addFringeToFavourites : function (fringe_id, callback)
	{
		var params={'fringe_id':fringe_id.toString()};
		FlurryAgent.logEvent("favourite_add_fringe", params);
		Favourites._addItemToFavourites( fringe_id, callback, "fringe_id");
	},
	// adds agenda to favourites and make a notification
	addExhibitorToFavourites : function (exhibitor_id, callback)
	{
		var eventParameters={}; 
		eventParameters['exhibitor_id'] = exhibitor_id.toString();
		FlurryAgent.logEvent("favourite_add_exhibitor", eventParameters); 

		Favourites._addItemToFavourites( exhibitor_id, callback, "exhibitor_id");
	},// adds agenda to favourites and make a notification
	addGpslocationToFavourites : function (gpslocation_id, callback)
	{
		var eventParameters={}; 
		eventParameters['gpslocation_id'] = gpslocation_id.toString();
		FlurryAgent.logEvent("favourite_add_gpslocation", eventParameters); 

		Favourites._addItemToFavourites( gpslocation_id, callback, "gpslocation_id");
	},
	
	// adds agenda to favourites and make a notification
	_addItemToFavourites : function (item_id, callback, column)
	{

		db.transaction(function (tx) {
			Favourites._create_table_if_not_exist(tx);
			var d = new Date();
			var timenow = Math.floor(d.getTime()/1000);
			if( !m_use_webserver_sql )
			{
				tx.executeSql('INSERT INTO favourites (id, '+column+') VALUES (?,?)', [timenow, item_id],
					function ()
					{
						if( callback != null )
						{
							callback();
						}
					}
				);
			}
		});
		

		Favourites.resetAllNotification();
	},

	removeAgendaItemFromFavourites : function (agendaitem_id, callback)
	{
		Favourites._removeItemFromFavourites(agendaitem_id, callback, "agendaitem_id");
	},
	removeFringeFromFavourites : function (fringe_id, callback)
	{
		Favourites._removeItemFromFavourites(fringe_id, callback, "fringe_id");
	},
	removeExhibitorFromFavourites : function (exhibitor_id, callback)
	{
		Favourites._removeItemFromFavourites(exhibitor_id, callback, "exhibitor_id");
	},
	removeGpslocationFromFavourites : function (gpslocation_id, callback)
	{
		Favourites._removeItemFromFavourites(gpslocation_id, callback, "gpslocation_id");
	},
	_removeItemFromFavourites : function (item_id, callback, column)
	{
		db.transaction(function (tx) {
				tx.executeSql("DELETE FROM favourites WHERE "+column+" = "+item_id+"", [],
					function ()
					{
						if( callback != null )
						{
							callback();
						}
					},
					function onerror( sql, err )
					{
						dalert( "Error performing delete favourite:"+err.message );
					}
				);
			}
		);
		
		Favourites.resetAllNotification();
	},
	
	// Checks if the agendaitem_id value is in the favourites table.
	checkIfAgendaExists : function (agendaitem_id, callback)
	{
		Favourites._checkIfItemExists(agendaitem_id, callback, "agendaitem_id" );
	},
	checkIfFringeExists : function (fringe_id, callback)
	{
		Favourites._checkIfItemExists(fringe_id, callback, "fringe_id" );
	},
	checkIfExhibitorExists : function (exhibitor_id, callback)
	{
		Favourites._checkIfItemExists(exhibitor_id, callback, "exhibitor_id" );
	},
	checkIfGpslocationExists : function (gpslocation_id, callback)
	{
		Favourites._checkIfItemExists(gpslocation_id, callback, "gpslocation_id" );
	},
	_checkIfItemExists : function (item_id, callback, column)
	{
		var sql1 = "SELECT "+column+" FROM favourites WHERE "+column+"="+item_id+" ";
	
		db.transaction
		(
			function (tx) 
			{
				Favourites._create_table_if_not_exist(tx);
			
				tx.executeSql
				(
					sql1, [], 
					function onsuccess(tx, results)
					{
						var len = results.rows.length;
						
						if (len==0 ){
							callback( false );
						}
						else if ( len==1 )
						{
							callback( true );
						}
						else
						{
							dalert( "Multiple notifications exist for this." );
							callback( true );
						}						
					},
					function onfail(sql, err)
					{
						// This may be called if there is no favourite table created yet
						dalert( "Failed:checking favourite exists for "+column+" type:"+err.message );
						callback( false );
					}
				);
			}
			,
			function onerror(err)
			{
				// Probably couldn't open the db so say it's not found
				// dalert( "Error opening db in check:"+err.message);
				callback( false );
			}
		); //end of db transaction
	},
	
// AGENDA ITEMS	
	// Internal function to toggle an agenda item from being added or /removed
	_toggleAgendaItemFavourite : function ( agendaitem_id, on_added, on_removed )
	{
		if( !Favourites.m_adding_notification )
		{
			Favourites.m_adding_notification = true;
			// Check if it exists?
			Favourites.checkIfAgendaExists(agendaitem_id, 
				function( exists )
				{
					Favourites.m_adding_notification = false;
					if( exists )
					{
						Favourites.removeAgendaItemFromFavourites( agendaitem_id, on_removed );
					}
					else
					{							
						Favourites.addAgendaItemToFavourites( agendaitem_id, on_added );
					}
				}
			);
		}
	},
	createToggleButtonForAgendaItem : function( button_name, agendaitem_id )
	{
		//	class = "block block_button clickable localise"
		try
		{
			var text_when_in_favourites = "<div class='block block_button clickable favourited_button favourited_colour_yes'><img src='img/favourite_on.png' class='favourite_star_size'></img>A reminder has been set, click to unset this</div>";
			var text_when_not_in_favourites = "<div class='block block_button clickable favourited_button favourited_colour_no'><img src='img/favourite_off.png' class='favourite_star_size'></img>Add a reminder 15mins before?</div>";
			
			// Set up original state of button
			$(button_name).text( "" );
			Favourites.checkIfAgendaExists(agendaitem_id, function( exists )
				{
					if( exists )
					{
						$(button_name).html( text_when_in_favourites );
					}
					else
					{
						$(button_name).html( text_when_not_in_favourites );
					}
				} 
			);
				
			$(button_name).click(
				function onclick() 
				{
					Favourites._toggleAgendaItemFavourite( agendaitem_id, 
						function on_added()
						{
							$(button_name).html( text_when_in_favourites );
						}
						,
						function on_removed()
						{
							$(button_name).html( text_when_not_in_favourites );
						}
					);
				}
			);
		}
		catch(e)
		{
			dalert("Exception in toggle favourites"+e.message);
		}
	},


	// FRINGES
	// Internal function to toggle an fringe item from being added or /removed
	_toggleFringeFavourite : function ( fringe_id, on_added, on_removed )
	{
		if( !Favourites.m_adding_notification )
		{
			Favourites.m_adding_notification = true;
			// Check if it exists?
			Favourites.checkIfFringeExists(fringe_id, 
				function( exists )
				{
					Favourites.m_adding_notification = false;
					if( exists )
					{
						Favourites.removeFringeFromFavourites( fringe_id, on_removed );
					}
					else
					{							
						Favourites.addFringeToFavourites( fringe_id, on_added );
					}
				}
			);
		}
	},
	



	createToggleButtonForFringe : function( button_name, fringe_id )
	{
		// Version from local2014 to prevent crash
		try
		{
			var text_when_setting  = '<div class="button_wide"><img src="img/favourite_on.png" class="favourite_star_size_small_for_button"></img>Updating...</div>';
			var text_when_in_favourites = '<div class="button_wide"><img src="img/favourite_on.png" class="favourite_star_size_small_for_button"></img>Reminder now set</div>';
			var text_when_not_in_favourites = '<div class ="button_wide"><img src="img/favourite_off.png" class="favourite_star_size_small_for_button"></img>Add to your favourites?</div>';
			
			// Set up original state of button
			$(button_name).text( "" );
			Favourites.checkIfFringeExists(fringe_id, function( exists )
				{
					if( exists )
					{
						$(button_name).html( text_when_in_favourites );
					}
					else
					{
						$(button_name).html( text_when_not_in_favourites );
					}
				} 
			);
				
			$(button_name).click(
				function onclick() 
				{
					$(button_name).html( text_when_setting );
					LocalNotifications.ClearAllNotifications();
					// Only set the notification after a slight delay as a work around on thread race condition crash on iOS
					setTimeout( function()
						{
							Favourites._toggleFringeFavourite( fringe_id, 
								function on_added()
								{
									$(button_name).html( text_when_in_favourites );
								}
								,
								function on_removed()
								{
									$(button_name).html( text_when_not_in_favourites );
								}
							);
						}
						, 500 
					);					
				}
			);
		}
		catch(e)
		{
			dalert("Exception in toggle fringe favourites"+e.message);
		}
	},



// EXHIBITORS
	// Internal function to toggle an exhibitor item from being added or /removed
	_toggleExhibitorFavourite : function ( exhibitor_id, on_added, on_removed )
	{
		if( !Favourites.m_adding_notification )
		{
			Favourites.m_adding_notification = true;
			// Check if it exists?
			Favourites.checkIfExhibitorExists(exhibitor_id, 
				function( exists )
				{
					Favourites.m_adding_notification = false;
					if( exists )
					{
						Favourites.removeExhibitorFromFavourites( exhibitor_id, on_removed );
					}
					else
					{							
						Favourites.addExhibitorToFavourites( exhibitor_id, on_added );
					}
				}
			);
		}
	},
	
// GPSLOCATION
	// Internal function to toggle an exhibitor item from being added or /removed
	_toggleGpslocationFavourite : function ( gpslocation_id, on_added, on_removed )
	{
		if( !Favourites.m_adding_notification )
		{
			Favourites.m_adding_notification = true;
			// Check if it exists?
			Favourites.checkIfGpslocationExists(gpslocation_id, 
				function( exists )
				{
					Favourites.m_adding_notification = false;
					if( exists )
					{
						Favourites.removeGpslocationFromFavourites( gpslocation_id, on_removed );
					}
					else
					{							
						Favourites.addGpslocationToFavourites( gpslocation_id, on_added );
					}
				}
			);
		}
	},
	
	
	createToggleButtonForGpslocation : function( button_name, gpslocation_id )
	{
		//	class = "block block_button clickable localise"
		try
		{
			
			var text_when_in_favourites = '<div class="button_wide"><img src="img/favourite_on.png" class="favourite_star_size_small_for_button"></img>Favourite Added</div>';
			var text_when_not_in_favourites = '<div class ="button_wide"><img src="img/favourite_off.png" class="favourite_star_size_small_for_button"></img>Add to your favourites?</div>';
			
			// Set up original state of button
			$(button_name).text( "" );
			Favourites.checkIfGpslocationExists(gpslocation_id, function( exists )
				{
					if( exists )
					{
						$(button_name).html( text_when_in_favourites );
					}
					else
					{
						$(button_name).html( text_when_not_in_favourites );
					}
				} 
			);
				
			$(button_name).click(
				function onclick() 
				{
					Favourites._toggleGpslocationFavourite( gpslocation_id,
						function on_added()
						{
							$(button_name).html( text_when_in_favourites );
						}
						,
						function on_removed()
						{
							$(button_name).html( text_when_not_in_favourites );
						}
					);
				}
			);
		}
		catch(e)
		{
			dalert("Exception in toggle Gpslocation favourites"+e.message);
		}
	},	
	createToggleButtonForExhibitor : function( button_name, exhibitor_id )
	{
		//	class = "block block_button clickable localise"
		try
		{
			
			var text_when_in_favourites = '<div class="button_wide"><img src="img/favourite_on.png" class="favourite_star_size_small_for_button"></img>Favourite Added</div>';
			var text_when_not_in_favourites = '<div class ="button_wide"><img src="img/favourite_off.png" class="favourite_star_size_small_for_button"></img>Add to your favourites?</div>';
			
			// Set up original state of button
			$(button_name).text( "" );
			Favourites.checkIfExhibitorExists(exhibitor_id, function( exists )
				{
					if( exists )
					{
						$(button_name).html( text_when_in_favourites );
					}
					else
					{
						$(button_name).html( text_when_not_in_favourites );
					}
				} 
			);
				
			$(button_name).click(
				function onclick() 
				{
					Favourites._toggleExhibitorFavourite( exhibitor_id, 
						function on_added()
						{
							$(button_name).html( text_when_in_favourites );
						}
						,
						function on_removed()
						{
							$(button_name).html( text_when_not_in_favourites );
						}
					);
				}
			);
		}
		catch(e)
		{
			dalert("Exception in toggle exhibitor favourites"+e.message);
		}
	}	
}