	// Resize any items with a given class name
	// headery - Pixels from top of screen
	// footery - Pixels from bottoms
	// margin_x - Margin around buttons (Subtracts from button size)
	// margin_y - Margin around buttons
	// max_size - maximum button size in px
	function grid_resize_items( class_to_search, sections, headery, footery, margin_x, margin_y, max_size )
	{
		var max_buttons = $( "."+class_to_search ).length;
		if( max_buttons == 0 )
		{
			dalert( 'No buttons found to resize' );
		}
		var w = get_container_max_width();//window.innerWidth;
		var h = window.innerHeight;
		var max_rows = Math.floor(max_buttons/sections);
		if( max_rows < 1 )
		{
			max_rows = 1;
		}
		if( w > h )
		{
			max_rows = sections;
		}
		var height_for_grid = (h - headery - footery);
		var row_height =  Math.floor( height_for_grid / max_rows);
		if( row_height > max_size )
		{
			row_height = max_size;
		}
		var columns_per_row = Math.ceil( max_buttons / max_rows );

		var buttonid = 0;
		var row = 0;
		var column = 0;
		var sizex = w / columns_per_row;
		var sizey = height_for_grid / max_rows;
		// Make sure it picks the smaller of the two requirements
		var size = sizex - margin_x;
		if( size > (sizey - margin_y))
		{
			size = (sizey - margin_y);
		}
		
		// Make sure the buttons don't get too big
		var button_size = size;
		if( size > max_size )
		{
			button_size = max_size;
		}
		
		// This is to adjust the entire grid so it is centered
		var centering_offset_x = 0;//( size - button_size) / 2;
		var centering_offset_y = ( (height_for_grid)- ( max_rows * row_height ) ) / 2;
		
		
		$('.'+class_to_search).each(
			function(i, obj) 
			{
				var buttonid = i; // Counter
				row = Math.floor(buttonid / columns_per_row);
				column = buttonid - ( row * columns_per_row );
				
				if( obj != null )
				{
					var offset_from_centerx = (column - (columns_per_row / 2) );
					offset_from_centerx = offset_from_centerx * (button_size + margin_x);
					
					//obj.style.left =( centering_offset_x + offset_from_centerx + (w/2)) + "px";
					
					
					var left = ( column * ( button_size + margin_x ));
					var fullwidthofgrid = columns_per_row * ( button_size + margin_x );

					// Shift to center this grid area in the screen width
					left += (w - fullwidthofgrid + margin_x) / 2;
					
					// Offset for the size of the button
					obj.style.left = Math.floor(left) + "px";
					obj.style.top  =Math.floor( centering_offset_y + ( row * row_height ) + headery + (margin_y / 2) )+"px";
					
					obj.style.width = Math.ceil(button_size) + "px";
					obj.style.height = Math.ceil(button_size) + "px";
				}
				else
				{
					dalert( "Could not find button"+buttonid );
				}
			}
		);
	}				

		// Resize any items with a given class name
	// headery - Pixels from top of screen
	// footery - Pixels from bottoms
	// margin_x - Margin around buttons (Subtracts from button size)
	// margin_y - Margin around buttons
	// max_size - maximum button size in px
	function vertical_align( class_to_search, headery, footery, margin_x, margin_y, max_size )
	{
		var max_rows = $( "."+class_to_search ).length;
		if( max_rows == 0 )
		{
			dalert( 'No buttons found to resize' );
		}
		var w = get_container_max_width();//window.innerWidth;
		var h = window.innerHeight;

		var height_for_grid = (h - headery - footery);
		var row_height =  Math.floor( height_for_grid / max_rows);
		if( row_height > max_size )
		{
			row_height = max_size;
		}

		var buttonid = 0;
		var row = 0;
		var sizey = height_for_grid / max_rows;
		var left = margin_x/2;
		
		
		// This is to adjust the entire grid so it is centered
		var centering_offset_x = margin_x / 2;
		var centering_offset_y = ( (height_for_grid)- ( max_rows * row_height ) ) / 2;
		
		
		$('.'+class_to_search).each(
			function(i, obj) 
			{
				var buttonid = i; // Counter
				row = buttonid;
				
				if( obj != null )
				{
					// Offset for the size of the button
					obj.style.left = Math.floor(left) + "px";
					obj.style.top  = Math.floor( centering_offset_y + ( row * row_height ) + headery + (margin_y / 2) )+"px";
					
					obj.style.width = Math.ceil(w - margin_x ) + "px";
					obj.style.height = Math.ceil(row_height - (margin_y / 2) ) + "px";
					obj.style.lineHeight = Math.ceil(row_height - (margin_y / 2) ) + "px";
				}
				else
				{
					dalert( "Could not find button"+buttonid );
				}
			}
		);
	}				


