var time_before_for_alert_in_seconds = 15 * 60;

var LocalNotifications = 
{
	ListenForEvents : function()
	{
		window.plugin.notification.local.on( 'click', function (id, state, jsonraw)
		{
			// Docs say it should be in jsonraw but found data in id.data
			try
			{
				var json = JSON.parse(id['data']);
				if( json != null )
				{
					//alert( "SR: Detected localnotification click:"+json + " json['page']:"+json['url']+ " json['type']:"+json['type'] );
					// We have some data!
					if( json['type'] == "show_page" )
					{
						// Navigate to fringe info page for this item
						set_pending_page( json['url'] );
					}
					
				}
				else
				{
	//alert("Click detected but no JSON"+id+" state:"+state+" json:"+json );
				}
			}
			catch(e)
			{
				alert("Exception parsing onclick"+e);
			}
		} );

	},


	AddNotification : function( item_id, title, description, epochtime, page_url )
	{
		// Fix to make sure we only use random item_id's since having the same ID seems to cause a crash!
		item_id = Math.floor(Math.random() * 100000000 )+item_id;
		
	
		var dateobject = new Date(0);
		var now = new Date();
		var epochnow = (now.getTime()/1000);
		
		
		if( m_disable_localnotifications )
		{
			dlog('Local notifications in are disabled for testing.  Reenable in defines.js');
			return;
		}
		
        if( m_debug_localnotifications_force_in_30_seconds )
        {
             epochtime = epochnow + 60;
        }
		dateobject.setUTCSeconds( epochtime );
		var epochdate = dateobject.getTime()/1000;
        
		
		dlog( "Notification "+item_id+" added for time:"+epochtime+" saying:"+description );
		if( true ) //if( window.plugin )
		{
			try
			{	
				if( epochnow > epochdate )
				{
					if( m_debug_alarm )
					{
						dalert( "Old alarm, skipped for:"+description+" at time:"+epochdate+" when current time is:"+epochnow );
					}
				}
				else
				{
					if( m_debug_alarm )
					{
						dalert( "Alarm SET for:"+description+" at time:"+epochdate+" when current time is:"+epochnow );
					}
					var json_data = {
						type:"show_page",
						url:page_url
					};
					window.plugin.notification.local.add(
						{
							id:      item_id,
							title:   'Reminder',
							message: description,
							json:  JSON.stringify(json_data),
							date:    dateobject // Was 20160902 epochdate
						}
					);
				}
			}
			catch( exception )			
			{
				derror( "No notification plugin loaded for setting agenaitem:"+item_id+"  epochdate:"+epochtime+" description:"+description );
			}
		}
		else
		{
			derror( "Add Notifications Not Possible because there is no notification plugin" );
		}
	},

	// This removes all local notifications
	ClearAllNotifications : function ()
	{
		if( m_disable_localnotifications )
		{
			alert('Local notifications in are disabled for testing.  Reenable in defines.js');
			return;
		}
	
		dlog( "All Notifications Cleared" );
		try
		{	
			window.plugin.notification.local.cancelAll(
				function () 
				{
					// All notifications have been canceled
				}
			);
		}
		catch( exception )			
		{
			derror( "No notification plugin loaded for clearing" );
		}
	}
}