/* Notes:
 * - History management is currently done using window.location.hash.  This could easily be changed to use Push State instead.
 * - jQuery dependency for now. This could also be easily removed.
 */
var m_already_loading = false;

function get_is_page_loading()
{
	return m_already_loading;
}
function lock_page_changes()
{
	m_already_loading = true;
}
function unlock_page_changes()
{
	m_already_loading = false;
}

function scroll_to_top_smoothly()
{
	$("html, body").animate({ scrollTop: 0 }, "slow");
}


function PageSlider(container) {

    var container = container,
        currentPage,
        stateHistory = [];

    // Use this function if you want PageSlider to automatically determine the sliding direction based on the state history
    this.slidePage = function(pagename, pagehtml) {

        var l = stateHistory.length,
            state = pagename;


        if (l === 0) {
            stateHistory.push(state);
			this.showBackButtonIfNecessary();
            this.slidePageFrom(pagehtml);
            return;
        }
		

		
		// TODO check if this page has ever existed in the history and slide back to this!
		var found = false;
		var moveleft = false;
		do
		{
			found = false;
			l = stateHistory.length;
			for( var counter=0;counter <= (l-2);counter++)
			{
				if(state === stateHistory[counter])
				{
					// Right we've found it in the history!
					stateHistory.pop();
					found = true;
					moveleft = true;
					break;
				}
			}
		} while( found );


        if (moveleft) 
		{
            this.slidePageFrom(pagehtml, 'left');
			this.showBackButtonIfNecessary();
        }
		else 
		{
            stateHistory.push(state);
			this.showBackButtonIfNecessary();
            this.slidePageFrom(pagehtml, 'right');
        }
    };
	
	
	
	this.clearCurrentPages = function ()
	{
		container.empty();
	};
	
	
	
	this.showBackButtonIfNecessary = function()
	{
		if((window.location.hash=="mainmenu") || (window.location.hash=="") )
		{
			// We can go back so show back button
			$('#back_button').hide();
		}
		else
		{
			$('#back_button').show();
		}
	};
	
	
	// Will reload the current page 
	this.reloadPage = function(pagename, pagehtml) 
	{
		var l = stateHistory.length,
        state = pagename;
		

		var position = stateHistory.length - 1;
		if( position >= 0 )
		{
			if( stateHistory[ stateHistory.length - 1 ] == pagename )
			{
				this.slidePageFrom(pagehtml);
			}
			else
			{
				dalert( "Reloading a page that differs from the stack's most recent page" );
			}
		}
		else
		{
			dalert( "Reloading a page when nothing has been loaded yet" );
		}
	};

    // Use this function directly if you want to control the sliding direction outside PageSlider
    this.slidePageFrom = function(pagehtml, from) {

		// Work around just in case a callback for a transition doesn't complete
		//alert( "Container has "+container.length+" items ");
		if( container.length > 1 )
		{
			dalert( 'deleting an erroneous page' );
			for( var i = container.length - 1; i > 0 ; i-- )
			{
				container[i].remove();
			}			
		}
	

        if (!currentPage || !from) {
			if( !from )
			{
				container.empty();
			}
			
			var page = $("<div/>", {html: pagehtml} );
            page.attr("class", "page center");
			localise_pages( page );				

			container.append(page);
            currentPage = page;
			unlock_page_changes();
            return;
        }
		var page = $("<div/>", {html: pagehtml} );
		localise_pages( page );				



        // Position the page at the starting position of the animation
        page.attr("class", "page " + from);

		container.append(page);

		// Delete the old page when the transition completes (was one)  UGLY HACK! This should be one but using on since the up/down arrow animations in iscroll are causing a random error where it doesn't get called.
		/*
        currentPage.on('mstransitionend', function(e) {
		alert('in mstransitionend');
            $(e.target).remove();
			unlock_page_changes();
			scroll_to_top();
        });
		$.support.transition.end( function()
			{
				alert('in jquery transition end');
			} 
		);
		*/
        currentPage.on('webkitTransitionEnd', function(e) {
            $(e.target).remove();
			unlock_page_changes();
			scroll_to_top();
        });
        currentPage.on('transitionend', function(e) {
			$(e.target).remove();
			unlock_page_changes();
			scroll_to_top();
        });
		

        // Force reflow. More information here: http://www.phpied.com/rendering-repaint-reflowrelayout-restyle/
        container[0].offsetWidth;

        // Position the new page and the current page at the ending position of their animation with a transition class indicating the duration of the animation
        page.attr("class", "page transition center");
        currentPage.attr("class", "page transition " + (from === "left" ? "right" : "left"));
        currentPage = page;

        //Refesh code
		/*
        jQuery(function($) {
			var $style = $('#styles');
			
		    var $ed = $('#container');
		    $ed.val($style.html());
		        $style.html($ed.val());
		        return false;
		});
		*/
        //End of refesh code
    };
	
	

}