var m_target_percentage;
var m_current_percentage;
var m_progress_bar_timer = null;

function progressbar_start()
{
	document.getElementById("progress_overlay").style.display = "block";
	document.getElementById("progress_info").style.display = "block";
	$("#progress_overlay").fadeTo( "slow" , 0.50 );
	$("#progress_info").fadeTo( "slow" , 1.00 );
	
	m_current_percentage = 0;
	m_target_percentage = 0;
}
 
 
// Update the text displayed on the progress bar
function progressbar_update_text(text)
{
    document.getElementById("progress_text").innerHTML = text;
}

// Update the progress bar  (Normalized value from 0 to 1)
function progressbar_update_percentage(target_percentage)
{
	m_target_percentage = target_percentage;
	if( m_progress_bar_timer != null )
	{
		clearInterval(m_progress_bar_timer);
		m_progress_bar_timer = null;
	}
	m_progress_bar_timer = setInterval(function(){progressbar_timer_update()},25);
}

//local_counter = 0;
function progressbar_timer_update()
{
	m_current_percentage = (m_current_percentage * 0.9 ) + (m_target_percentage * 0.1);
	if( m_current_percentage > 1 )
	{
		m_current_percentage = 1;
	}
	
	// Turn off timer callback if goal reached
	var diff =  m_current_percentage - m_target_percentage;
	if( diff < 0 )
	{
		diff = -diff;
	}
	if( diff < 0.01 )
	{
		if( m_progress_bar_timer != null )
		{
			clearInterval(m_progress_bar_timer);
			m_progress_bar_timer = null;
		}
	}
	var show_percentage = Math.round(m_current_percentage * 100 );
    $("#progress_bar").css('width',show_percentage+"%");
	document.getElementById("progress_percent").innerHTML = show_percentage+"%";
	
	//local_counter = local_counter + 1;
	//dlog("updating progress"+local_counter);
}





// Hide the progress bar
function progressbar_stop()
{
	// Leave onscreen
	$("#progress_overlay").fadeTo( "slow" , 0.0, function()
		{
			document.getElementById("progress_overlay").style.display = "none";
		}
	);
	$("#progress_info").fadeTo( "slow" , 0.0, function()
		{
			document.getElementById("progress_info").style.display = "none";
		}
	);
//	
}



// Testing functions only
var progress_bar_test_timer; 
function progressbar_test()
{
	progressbar_start();
	progress_bar_test_timer = setInterval(function(){myTimer()},25);
	document.getElementById("progress_overlay").style.display = "block";
	document.getElementById("progress_info").style.display = "block";
}

// Testing routine
var percentage = 0;
function myTimer() 
{
	percentage = percentage+0.02;
    progressbar_update_text( "Loading AgendaItems" );
	progressbar_update_percentage( percentage );
	if( percentage > 1 )
	{
		progressbar_stop();
		progress_bar_test_timer = null;
	}
}
