// Written by Stuart Radforth
// Copyright Aszart Ltd 2015
// 2015/02/07
// Tested on iOS, Android, WP8, Chrome, IE
// Requires jquery

/* The following needs to be in the CSS 
.banner_area
{
	text-align:center;
}
.banner_existing_image_area
{
	border-radius:8px;
	z-index:1;
}
.banner_new_image_area
{
	border-radius:8px;
	z-index:2;
}

.banner_image
{
	height:100%;
	border-radius:8px;
	box-shadow: 0px 0px 8px #000000;
}


Call in script via
	var images_to_rotate_banner1 = [
		{ image:'img/advert_aeee.jpg',				url:'exhibitor_info.html?exhibitor_id=1623' },
		{ image:'img/advert_acc.jpg', 				url:'exhibitor_info.html?exhibitor_id=1624' },
		{ image:'img/advert_bdi.jpg', 				url:'exhibitor_info.html?exhibitor_id=1584' },
		{ image:'img/advert_twitter.jpg', 			url:'https://twitter.com/#airportsymp' }
	];

	var seconds_for_crossfade1 = 1;
	var seconds_until_swap1 = 3;
	
	var banner1 = new Banner( "#your_id_div_tag_here", 100, "bottom:10px;width:20%;text-align:right", images_to_rotate_banner1,banner_navigate_to, seconds_for_crossfade1, seconds_until_swap1 );

*/

// When the advert is pressed this is called
function banner_navigate_to(url, banner_id)
{
	//alert( 'Pressed '+url + " banner_id:"+banner_id );
	navigate_to_page('url');
}
	

	
// --------------------------- BANNER CODE --------------------------------------------
	
// Globals
var g_banner_id = 0; // Must have this global variable to track which banner has been created.



// Issues: Transparency shows a duplicate glitch on many devices as it swaps from new to existing images.
// TODO: Perhaps rewrite so there are two images A and B and simply cross fade these back and forth changing the Z index.
// add_to_this_id_string - '#addhere' DOM element
// banner_height - height in pixels to set banner to
// style_position - set the absolute top/bottom left/right cordinates such as "bottom:10px;width:100%;"
// images_to_rotate - array of image objects [ {image:'myimage1.jpg'}, {image:'myimage2',url:'navtohere.html'}]
// fn_callback_on_click - Function to call when the banner is called myfunction(url, banner_id)
// seconds_for_crossfade (optional)
// seconds_until_swap (optional)
function Banner( add_to_this_id_string, banner_height, style_position, images_to_rotate, fn_callback_on_click, seconds_for_crossfade, seconds_until_swap )
{
	var m_seconds_for_crossfade;
	var m_seconds_until_swap;
	var m_banner_allow_cycling;
	var m_images_to_rotate;
	var m_banner_id;
	var m_banner_counter;
	var m_fn_callback_on_click;
	
	

	
	
	// Call this to stop the cycling
	this.stop = function()
	{
		m_banner_allow_cycling = false;
	}
	


	// This sets the opaque image to show.  It is usually called on launch and once a new image has completed fading it this will be called to set the background image to the newly faded in one.
	this._set_existing_area_and_prep_next_image = function ()
	{
		var existing_image_path = this.m_images_to_rotate[ this.m_banner_counter ]['image'];
		var existing_image_url = this.m_images_to_rotate[ this.m_banner_counter ]['url'];
		
		// Send the front image to the back.
		$('#banner_existing_image_area'+this.m_banner_id).html( '<img src="'+existing_image_path+'" class="banner_image" onclick="banner_navigate_to(\''+existing_image_url+'\')">' );
		$('#banner_existing_image_area'+this.m_banner_id).fadeTo(0, 1.0);
		
		// Select next item
		this.m_banner_counter = this.m_banner_counter + 1;
		if( this.m_banner_counter >= this.m_images_to_rotate.length )
		{
			this.m_banner_counter = 0;
		}		
		
		// Set up new image ready to fade in later
		var new_image_path = this.m_images_to_rotate[ this.m_banner_counter ]['image'];
		var new_image_url = this.m_images_to_rotate[ this.m_banner_counter ]['url'];
		var that = this;
		setTimeout( function()
		{
			$('#banner_new_image_area'+that.m_banner_id).fadeTo(0,0.0);
			$('#banner_new_image_area'+that.m_banner_id).html( '<img src="'+new_image_path+'" class="banner_image" onclick="'+that.m_fn_callback_on_click+'(\''+existing_image_url+'\', '+that.m_banner_id+')">' );
			
			// Check we are still on the main page!
			if( $('#banner_new_image_area'+that.m_banner_id) != null ) 
			{
				if( that.m_banner_allow_cycling == true )
				{
					setTimeout( function on_timer()
						{
							that.banner_fade_next();
						}, that.m_seconds_until_swap * 1000 );
				}
				else
				{
					alert("SR:Banner stopped2, Tag says to stop");
				}
			}
			else
			{
				alert("SR:Banner stopped3. Missing item");
			}
		},10 );
	}

	
	
	// Will recursively call itself via timeout threads until it can't find the image to update
	this.banner_fade_next = function()
	{
		// Create new image
		if( $('#banner_new_image_area'+this.m_banner_id) != null )
		{
			// Make sure the background image fades out faster than the foreground since 
			$('#banner_existing_image_area'+this.m_banner_id).fadeTo(this.m_seconds_for_crossfade * (1000/2),0.0);
			
			var that = this;
			$('#banner_new_image_area'+this.m_banner_id).fadeTo(this.m_seconds_for_crossfade * 1000,1.0, 
				function on_completed_fadein() 
				{
					
					that._set_existing_area_and_prep_next_image();
				}
			);
		}
		else
		{
			alert("SR:Banner stopped1");
		}
	}
		
		
		

	// Initialize Object
	// Make sure we have a unique id for this banner
	if( g_banner_id == null )
	{
		g_banner_id = 1;
	}
	else
	{
		g_banner_id = g_banner_id + 1;
	}
	
	this.m_banner_id = g_banner_id;
	
	
	// Get the string version of the function to call
	var ret = fn_callback_on_click.toString();
	ret = ret.substr('function '.length);
	ret = ret.substr(0, ret.indexOf('('));
	
	this.m_fn_callback_on_click = ret;
	
	var htmltoadd = '<div class="banner_area" style="height:'+banner_height+'px;position:absolute;'+style_position+'">\
						<div id="banner_existing_image_area'+this.m_banner_id+'" class="banner_existing_image_area" style="height:'+banner_height+'px;">\
						</div>\
					</div>\
					<div class="banner_area" style="height:'+banner_height+'px;position:absolute;'+style_position+'">\
						<div id="banner_new_image_area'+this.m_banner_id+'" class="banner_new_image_area" style="opacity:0.0;height:'+banner_height+'px;">\
						</div>\
					</div>';
	$( add_to_this_id_string ).html(htmltoadd);

	
	
	this.m_seconds_for_crossfade = 1;
	this.m_seconds_until_swap = 3;
	if( seconds_for_crossfade != null )
	{
		this.m_seconds_for_crossfade = seconds_for_crossfade;
	}
	if( seconds_until_swap != null )
	{
		this.m_seconds_until_swap = seconds_until_swap;
	}
	this.m_banner_allow_cycling = true; // Enable the cycling.  
	this.m_images_to_rotate = images_to_rotate;
	this.m_banner_counter = Math.floor( Math.random() * this.m_images_to_rotate.length); // Which banner to start on
	// Now start the recurive fade
	// Make sure we show one image on screen from the outset
	this._set_existing_area_and_prep_next_image();
		
}	
