// db.transaction( call, error(not wp8), success(not wp8) )
//  tx.executeSql( SQL call, [],  callback, error )

var m_db_name = 'database_v44_';



function on_tx_success( tx, results )
{
	dlog( 'Execute SQL completed' );
}
 
function on_tx_error( err )
{
	dalert( "SQL Error"+err );
}						


var lastonline = -10;
var m_first_show_no_internet = true;
function is_network_to_server_available()
{
	if( m_simulate_no_internet_connection )
	{
		if( m_first_show_no_internet )
		{
			m_first_show_no_internet = false;
			alert("DEBUG: NO INTERNET CONNECTION USED. REMOVE THIS!!!");
		}
		return false;
	}
	var online = aszart_network_online;//navigator.onLine;
	if( lastonline !== online )
	{
		lastonline = online;
		dalert( 'Network status changed: '+online );
	}
	// TODO: Check if we can actually ping aszart.com
	return online;
}

// Called to sync all the data from a database for a given table and store it locally.
function get_data_for_table( table_name, on_completed )
{
	if( is_network_to_server_available() )
	{
		// Get the schema hash for this table if it exists
		var last_synced = 0;
		var primary_key = "NOTSET";
		var sql_get_version = "SELECT schema_hash, primary_key, last_synced FROM db_tables WHERE table_name='"+table_name+"' LIMIT 1";
		db.transaction(
			function (tx) 
			{
				tx.executeSql(sql_get_version, [], 
					function onsuccess(tx, results)
					{
						dlog("SR:get_data_for_table3");
						var schema_hash = "NOTFOUND";
						if( results == null )
						{
							derror( "null found for schema_hash in db_tables" );
						}
						else if( results.rows.length > 0 )
						{
							schema_hash = results.rows.item(0).schema_hash;
							last_synced = results.rows.item(0).last_synced;
							primary_key = results.rows.item(0).primary_key;
						}
						else
						{
							dlog( "No version results found" );
						}
						step2_on_schema_found_get_data_from_server( table_name, schema_hash, last_synced, primary_key, on_completed );
					},
					function onerror(err)
					{
						dlog("SR:get_data_for_table_on_error_3b");
						step2_on_schema_found_get_data_from_server( table_name, "NEWTABLE", 0, primary_key, on_completed );
						return false;
					}
				);
			}
			,						
			function(err)
			{
				// Error callback called also when the table db_tables doesn't exist yet
		//alert("SR:get_data_for_table3c");
				derror("get_data_for_table:error:"+err+" SQL"+sql_get_version);
//				step2_on_schema_found_get_data_from_server( table_name, "NEWTABLE", 0, primary_key, on_completed );
			}
		);
	}
	else
	{
		// no internet connection
		on_completed( false );
	}
}


function step2_on_schema_found_get_data_from_server( table_name, schema_hash, last_synced, primary_key, on_completed )
{
	// Get the data for a table given a schema hash
	// On response check if we're told to recreate table
	// Store the updated data in the table
	if( true )
	{
		var options ="";
		// If we're syncing the events table lets add on the version info
		if( table_name == 'events' )
		{
			options = "&version="+m_version+"&device_id="+get_unique_id_for_this_device();
		}
		var url =g_api_url+table_name+'/'+g_event_id+'/'+last_synced+'.json?schema_hash='+schema_hash+options;
//console.log("SR:syncing4"+url);
		
		$.getJSON( url )
			.done(
				function( json )
				{
//console.log("SR: JSON:");
//console.dir(json);
		dlog("SR:syncing5"+url);
					var text = '';
					//var len = json.length;
					step3_create_table_and_save_schema_hash( table_name, json, primary_key, on_completed );
					dlog( "Got response for "+table_name );
				}
			)
			.fail(
				function()
				{
		dlog("SR:syncing5b");
				
					derror( "ajax call failed on URL:"+url );
					on_completed( false );
				}
			);		
	}
	else
	{
		var json = 
		{
			"version":
				{
					"schema_hash":"hash1",
					"last_synced":"123101202",
					"XXXrecreate":"true"
				},
			"schema": 
				{
					"id": "integer unique",
					"name_first": "varchar(32)",
					"name_last": "varchar(32)",
					"postnominal": "varchar(32)",
					"company": "varchar(32)",
					"job_title": "varchar(32)",
					"biography": "varchar(1024)",
					"website": "varchar(32)",
					"email": "varchar(32)",							
					"date_modified": "integer",
					"thumb": "varchar(32)",
					"image": "varchar(32)"							
				},
			"data":
				[
					{
						"name_first": "Bruce",
						"name_last": "Bryant",
						"company": "The New York Times",
						"job_title": "Columnist & Author",
						"biography": "Adam Bryant writes the weekly Corner Office column for The New York Times, interviewing CEOs to find the nuggets of true leadership that are usually hidden between strategy sessions and quarterly reports. In his books, Bryant reveals the five qualities that set high-performers apart, and what it takes to build and foster a corporate culture of innovation.",
						"website": "http://www.nytimes.com/",
						"date_modified": "2014",
						"thumb": "aszart.com/triangulate/files/3/thspphoto186.jpg",
						"image": "aszart.com/triangulate/files/3/spphoto186.jpg",
						"id": "186"
					},
					{
						"name_first": "Al4",
						"name_last": "Pollard",
						"postnominal": "A.A.E.",
						"company": "Martin State Airport",
						"job_title": "Director",
						"email": "apollard@martinstateairport.com",
						"website": "http://www.marylandaviation.com/",
						"date_modified": "2014",
						"thumb": "aszart.com/triangulate/files/3/thspphoto230.jpg",
						"image": "aszart.com/triangulate/files/3/spphoto230.jpg",
						"id": "243"
					},
					{
						"delete":"true",
						"id": "241"
					},
					{
						"delete":"true",
						"id": "242"
					}
				]
		};
		step3_create_table_and_save_schema_hash( table_name, json, primary_key, on_completed );
	}
}

// This will add a new table to the database AND add it's properties to another table to track it's schema_hash
function step3_create_table_and_save_schema_hash( table_name, json, primary_key, on_completed )
{
	var schema = json['schema'];
	if( schema != null )
	{
		db.transaction(
			function (tx) 
			{
				dlog("SR:syncing6_step3: "+table_name);
		
				// Check if we need to recreate this table due to schema change or otherwise
				var version = json['version'];
				if( version['recreate'] == "true" )
				{
					dlog("SR:syncing6b"+table_name);
					var sql_delete = "DROP TABLE IF EXISTS " + table_name + ";";
					dlog( sql_delete );
					tx.executeSql( sql_delete,[], 
						function onsuccess()
						{
							dlog("SR:syncing6c_success:"+table_name);
							step3b_create_table_and_save_schema_hash( table_name, json, primary_key, on_completed );
						},
						function onerror(transaction, error)
						{
							dlog("SR:syncing6c_onerror:"+table_name+" error:"+error.message);
							step3b_create_table_and_save_schema_hash( table_name, json, primary_key, on_completed );
							return false;
						} 
					);
					dlog("SR:syncing6c"+table_name);
					
				}
				else
				{
					step3b_create_table_and_save_schema_hash( table_name, json, primary_key, on_completed );
				}
			}
		);
	}
	else
	{
		// Schema already exists but we go to update the contents anyhow as the last synched time needs updating
		step4_on_user_table_created_save_in_dbtables( table_name, json, primary_key, on_completed );
	}
	
}

function step3b_create_table_and_save_schema_hash( table_name, json, primary_key, on_completed )
{
	dlog("SR:syncing6_3bstart"+table_name);
	db.transaction(
		function (tx) 
		{
	dlog("SR:syncing6b"+table_name);
	
			// Check if we need to recreate this table due to schema change or otherwise
			var sql = "CREATE TABLE IF NOT EXISTS db_tables ( table_name VARCHAR(64) PRIMARY KEY, primary_key VARCHAR(64), schema_hash VARCHAR(128), last_synced INTEGER );";
	dlog("SR:syncing6bd"+table_name);
			dlog( sql );
			tx.executeSql( sql,[], 
				function onsuccess()
				{
	dlog("SR:syncing6be"+table_name);
					step4_on_user_table_created_save_in_dbtables( table_name, json, primary_key, on_completed );
				},

				function onerror(transaction, err)
				{
	dlog("SR:STOPPED syncing6bf"+table_name);
					derror( 'create_table_and_save_schema_hash:error:'+err.message);
					//alert("SR:syncing6f");
					return false;
				}
			);
		}
	);
}

// This will add a new table to the database AND add it's properties to another table to track it's schema_hash
function step4_on_user_table_created_save_in_dbtables( table_name, json, primary_key, on_completed )
{
	var schema = json['schema'];
	var version = json['version'];
	var schema_hash = version['schema_hash'];
	var last_synced = version['last_synced'];

	dlog("SR:syncing7");
	
	for (var prop in schema) 
	{
		if (schema.hasOwnProperty(prop)) 
		{
			var column_type = schema[ prop ];
			if( column_type.indexOf( "PRIMARY KEY" ) > -1 )
			{
				// make sure our primary key field is correct
				primary_key = prop;
				break;
			}
		}
	}
	
	
	db.transaction(
		function (tx)
		{
			var sql_table_version = "INSERT OR REPLACE INTO db_tables (table_name, primary_key, schema_hash, last_synced) VALUES ('"+table_name+"', '"+primary_key+"', '"+schema_hash+"', '"+last_synced+"' );"
			dlog( sql_table_version );
			//tx.executeSql( sql_table_version,[], on_tx_success, on_tx_error );
			tx.executeSql( sql_table_version,[],
				function onsuccess(tx, results)
				{
					step5_on_db_tables_exists_create_user_table( db, table_name, json, on_completed );
				},
				function onerror(transaction, err)
				{
					derror("step4_on_user_table_created_save_in_dbtables insert error:"+err.message) ;
					step5_on_db_tables_exists_create_user_table( db, table_name, json, on_completed );
				}
			);
		},
		function on_error(err)
		{
			derror("error adding to db_tables table:"+table_name+" version:"+version);
			return false;
		},
		function on_success(tx, results)
		{
		}
	);
}
			

// This will create a table in the database that doesn't already exist
function step5_on_db_tables_exists_create_user_table( db, table_name, json, on_completed )
{
	var sql_create = "";
	var primary_key = "NOTFOUND";
	var version_object = json['version'];
	var schema_hash = version_object['schema_hash'];
	var schema = json['schema'];
	if( schema_hash.length <= 0 )
	{
		dalert('No SHA found in version_object. Probably not valid JSON response');
		console.log("ERROR: Syncing SHA error" );
		return;
	}
	dlog("SR:syncing8");

	// We will only know the schema if the schema is new otherwise this object won't exist so can skip the create table step.
	if( schema )
	{
		var items = [];
		for (var prop in schema) 
		{
		  if (schema.hasOwnProperty(prop)) 
		  {
			var column_type = schema[ prop ];
			if( column_type.indexOf( "unique" ) > -1 )
			{
				primary_key = prop;
			}
			var item = prop + " " + column_type;
			items.push( item );
		  }
		}
		
		sql_create = "CREATE TABLE IF NOT EXISTS "+table_name+" (" + items.join(",") +");";
		dlog( sql_create );
		//document.querySelector('#status').innerHTML +=  sql_create + "<br/>";
		db.transaction(
			function (tx) 
			{
				tx.executeSql(sql_create, [], 
					function onsuccess(tx,results)
					{
						step6_on_user_table_created_add_data( table_name, json, primary_key, on_completed );
					},
					function onerror(transaction, err)
					{
						derror("create_table_and_save_version_after_versions_created: error:"+err.message) ;
						dlog("STOPPED");
					}
				);
			},
			function onerror(err)
			{
				derror("create_table_and_save_version_after_versions_created::: error:"+err.message) ;
				return false;
			},
			function onsuccess()
			{
			}
		);
	}
	else
	{
		step6_on_user_table_created_add_data( table_name, json, primary_key, on_completed );
	}
}
// db.transaction( call, error, success )
//  tx.executeSql( SQL call, [],  callback, error )

function insert_to_table( tx, sql_insert )
{
	//dlog( sql_insert );
	tx.executeSql( sql_insert,[],
		function onsuccess()
		{
			dlog("Success writing entry:"+sql_insert);
		}, 
		function onerror(transaction, error)
		{
			derror( "Error inserting: sql_insert:"+sql_insert+' error:'+error.message );
			return false;
		}
	);
}								

// With the db_table created, the table_name table created, the schema hash stored, now we're ready to update any data in the DB
function step6_on_user_table_created_add_data( table_name, json, primary_key, on_completed )
{
	var allitems = json['data'];
	var has_changed = false;
	dlog("SR:syncing9");

	if( allitems != null )
	{
dlog("SR:syncing9a");
		db.transaction(
			function add_item(tx) 
			{
dlog("SR:syncing9b");
				var number_of_items = allitems.length;
				var all_sql = "";
				var index = 1;
				if( number_of_items > 0 )
				{
					has_changed = true;
				}
				for( index = 0; index < number_of_items; index++)
				{
					var delete_this = false;
//dlog("SR:syncing9c");
				
					var columns = [];
					var values = [];
					var primary_value = -1;
					var dataitem = allitems[ index ];
					for (var prop in dataitem) 
					{
						if (dataitem.hasOwnProperty(prop)) 
						{
							if( prop == primary_key )
							{
								primary_value = dataitem[ prop ];
							}
							else if( prop == "DEL" )
							{
								delete_this = true;
							}
							
							columns.push( prop );
							values.push( "'" + dataitem[ prop ] + "'");
							
						}
					}
					
					if( dataitem['deleted'] != null )
					{
						if( dataitem['deleted'] == "1" )
						{
							delete_this = true;
						}
					}
					
					var sql_cols = columns.join(",");
					var sql_vals = values.join(",");
					var sql_insert;
					if( delete_this )
					{
						if( primary_key != "NOTFOUND" )
						{
							sql_insert = "DELETE FROM " + table_name + " WHERE " + primary_key + " = '" + primary_value + "';";
						}
						else
						{
							sql_insert = "";
						}
					}
					else
					{
						sql_insert = "INSERT OR REPLACE INTO " + table_name + "("+sql_cols+") VALUES (" + sql_vals + ");";
					}
					if( sql_insert != "" )
					{
						//console.log('sql:'+sql_insert);
						insert_to_table( tx, sql_insert );
					}
		dlog("SR:syncing_step9:"+table_name+" SQL:"+sql_insert);
		
				}
				on_completed( has_changed );
			}, 
			function(transaction, error)
			{
dlog("SR:syncing9e");
				derror("on_table_created_add_data:"+error.message) ;
				return false;
			},
			function onsuccess( tx, results )
			{
				// Call the completed data sync callback when completed
				//on_completed( has_changed );
			}
		);					
	}
	else
	{
		// No data to sync
		derror( "No Data To Sync" );
		on_completed();
	}
	
}




function on_completed()
{
	dalert( "Database Synchronised");
}

var m_current_sync_table_index = -1;
var m_array_tables_to_sync_TESTSPOTS = [
	{
		tablename:"maps",
		text:"Locations Maps"
	},
	{
		tablename:"spots",
		text:"Location Rooms"
	}
];


var m_array_tables_to_sync = [
	{
		tablename:"events",
		text:"Timezone"
	},
	{
		tablename:"news",
		text:"News Feed"
	},	
	{
		tablename:"speakers",
		text:"Speakers"
	},
	{
		tablename:"speakerroles",
		text:"Speakers"
	},
	{
		tablename:"agendaitems",
		text:"Timetable Events"
	}
	,
	{
		tablename:"fringes",
		text:"Fringe Events"
	}
	,
	{
		tablename:"agendaitems_speakers",
		text:"Fringe Events"
	},
	// {
		// tablename:"tracks",
		// text:"Events"
	// },
	// {
		// tablename:"sessions",
		// text:"Events"
	// },
	{
		tablename:"maps",
		text:"Locations Maps"
	},
	{
		tablename:"exhibitors",
		text:"Exhibitors"
	},
	{
		tablename:"spots",
		text:"Location Rooms"
	},
	{
		tablename:"gpstypes",
		text:"Venue Categories"
	},
	{
		tablename:"gpslocation",
		text:"Venue Locations"
	},
	{
		tablename:"barycentrics",
		text:"GPS References"
	},
	{
		tablename:"uiimages",
		text:"New Images"
 	}

];


function create_db_if_necessary( callback_when_exists )
{
	dlog('create_db_if_necessary1');
	if( db == null )
	{
		// Use WebSQL for browser, otherwise it's sqlite plugin
		if( !isPhoneGap() )
		{
			if( m_use_webserver_sql )
			{
				dalert( 'Using Server SQL' );
				db = new WebDB();
				/*
				db.transaction( function(tx){alert('some callback');}, 
					function onsuccess()
					{
						alert('success!');
					},
					function onerror()
					{
						alert('error!');
					}
				);				
				dalert( 'Using Server SQL2' );
				*/
				if( callback_when_exists != null )
				{
					callback_when_exists(null);
				}
			}
			else
			{
				dalert('Using WebSQL');
				db = openDatabase(m_db_name+g_event_id, '1.0', 'Triangulate', g_default_db_size, 
					function()
					{
						dlog('create_db_if_necessary3');
						if( callback_when_exists != null )
						{
							callback_when_exists(null);
						}
					},
					function onerror()
					{
						alert('create_db_error?');
					}
				);			
			}
		}
		else
		{
			dalert('Using sqlite cordova plugin');
			var dbname = m_db_name;
			if( g_event_id >= 0 )
			{
				dbname += g_event_id;
			}
			else
			{
				dbname += "unknown";
				dalert('Somehow sync_data() is being called with g_event_id value of:'+g_event_id);
			}
			// This is the same as WebSQL except the first parameter is different 2016/06/28
			try
			{
			
			var options =
			{
				name: dbname
			};
			
			options['iosDatabaseLocation'] = 'Library';
			var devicePlatform = device.platform;
			if( devicePlatform == "iOS" )
			{
				//options['iosDatabaseLocation'] = 'Library';
			}
			else
			{
				//options['location'] = 'Library';
				options['androidDatabaseImplementation'] = 1;
			}
			db = sqlitePlugin.openDatabase(
				options,
				function()
				{
					dlog('create_db_if_necessary3b');
					if( callback_when_exists != null )
					{
						callback_when_exists(null);
					}
				},
				function onerror()
				{
					alert('create_db_error?');
				}
			);
			}
			catch(e)
			{
				alert("Exception creating local database:"+e);
				callback_when_exists("error in database create");
			}
		}

		if( db == null )
		{
			derror('SQL failed to start, probably not supported in this browser!');
		}

		console.log('completed open db');
	}
	else
	{
		dlog('not recreated db as already created' );
		if( callback_when_exists != null )
		{
			callback_when_exists(null);
		}
	}
}




// Sync all data.  This is the external API call.
function sync_data()
{
	if( m_use_webserver_sql )
	{
		//dalert('Using web service for data. sync_data() exitted');
		create_db_if_necessary( null );
		return;
	}
	if( m_debug_disable_datasync )
	{
		alert('disabled for the moment!');
		return;
	}
	dalert( "SR:About to sync");
	create_db_if_necessary( 
		function()
		{
dalert( "SR:sync_data callback2");
					
			if( m_current_sync_table_index == -1 )
			{
				m_current_sync_table_index = 0;
				progressbar_start();
				// Call the recursive sync table method.  False means nothing has changed yet as this value is propogated
				sync_data_single_table( false );
			}
		}
	);
}



// This is recursively called to sync each table in turn until it completes
function sync_data_single_table(anything_changed)
{
	var tabletosync = m_array_tables_to_sync[m_current_sync_table_index];
	var tablename = tabletosync['tablename'];
	var text_to_display = tabletosync['text'];
console.log( 'syncing table:'+tablename );
	
	progressbar_update_text( text_to_display );
	progressbar_update_percentage( (m_current_sync_table_index + 1) / m_array_tables_to_sync.length );
	get_data_for_table( tablename, function on_completed( had_changes )
		{
			if( had_changes )
			{
				//alert(tablename+'sync completed with changes*');
				anything_changed = true;
			}
			else
			{
				//alert(tablename+'no changes detected');
			}
			
			m_current_sync_table_index++;
			if( m_current_sync_table_index < m_array_tables_to_sync.length )
			{
				sync_data_single_table(anything_changed);
			}
			else
			{
				sync_data_completed(anything_changed);
			}
		}
	);
}



var m_prevent_refresh_if_resynced = false;
// Called at the start of each page change
function allow_refresh_if_resynced()
{
    m_prevent_refresh_if_resynced = false;
}

// Called by a page if there is no way the database can effect it's contents so no need to disrupt the user's page
function prevent_refresh_if_resynced()
{
    m_prevent_refresh_if_resynced = true;
}



function sync_data_completed( anything_changed )
{
    // Send out an event that a page can listen to
	/*
    $.event.trigger({
                   type: "sync_data_completed",
                   message: "No details"
                   });
    */
	// Store this sync time so we know how long until we need to try to resync again on a resume.
	g_utc_last_sync_completed = get_utc_now();
	
	// Update any reminders in case they are different
	Favourites.resetAllNotification();

	progressbar_stop();
	EventDate.set_event_timezone_for_event();
	if( anything_changed )
	{
        if( !m_prevent_refresh_if_resynced )
        {
            // Reload the current page just incase any content has changed
            app_reload_current_page();
        }
	}
	
	// Flag we can do a download again
	m_current_sync_table_index = -1;

	download_new_uiimages();
}


