function urban_airship_setup()
{
	if( m_disable_urbanairhip )
	{
		alert( 'UrbanAirship is disabled for testing purposes. Reenable in defines.js before shipping');
		return;
	}
    try
    {
        // Incoming message callback
        var handleIncomingPush = function(event) {
            if(event.message) {
                console.log("Incoming push: " + event.message);
                showalert( localise_text("Notification"), event.message );
				
				// Navigate to the news page
				navigate_to_page('news.html');
            } else {
                console.log("No incoming message");
            }
        }
        
        // Registration callback
        var onRegistration = function(event)  {
            if (!event.error) {
                console.log("Reg Success: " + event.pushID);
                $('#id').text(event.pushID);
            } else {
                console.log(event.error);
            }
        }

        // Register for any urban airship events
        document.addEventListener("urbanairship.registration", onRegistration, false);
        document.addEventListener("urbanairship.push", handleIncomingPush, false);
        
        // Handle resume
        document.addEventListener("resume", function() {
                                  console.log("Device resume!")
                                  
                                  PushNotification.resetBadge()
                                  PushNotification.getIncoming(handleIncomingPush)
                                  
                                  // Reregister for urbanairship events if they were removed in pause event
                                  document.addEventListener("urbanairship.registration", onRegistration, false)
                                  document.addEventListener("urbanairship.push", handleIncomingPush, false)
                                  }, false);


        // Handle pause
        document.addEventListener("pause", function() {
                                  console.log("Device pause!")
                                  
                                  // Remove urbanairship events.  Important on android to not receive push in the background.
                                  document.removeEventListener("urbanairship.registration", onRegistration, false)
                                  document.removeEventListener("urbanairship.push", handleIncomingPush, false)
                                  }, false);

        // Register for notification types
        PushNotification.registerForNotificationTypes(PushNotification.notificationType.badge |
                                                      PushNotification.notificationType.sound |
                                                      PushNotification.notificationType.alert);

        // Get any incoming push from device ready open
        PushNotification.getIncoming(handleIncomingPush);
     
    }
    catch(e)
    {
        dalert("Error during setup of Urbanairship"+e.message);
    }
}



function urban_airship_setup2()
{
    try
    {
        if (typeof PushNotification != 'undefined')
        {

            // Make sure we register
            PushNotification.registerForNotificationTypes(PushNotification.notificationType.sound | PushNotification.notificationType.alert);

            // Callback for when a device has registered with Urban Airship.
            PushNotification.registerEvent('registration', function (error, id) {
                                           if (error) {
                                           console.log('there was an error registering for push notifications');
                                           dalert('there was an error registering for push notifications');
                                           } else {
                                           console.log("Registered with ID: " + id);
                                           dalert("Registered with ID: " + id);
                                           }
                                           });

            // Register for any urban airship events
            document.addEventListener("urbanairship.registration", function (event) {
                                      if (event.error) {
                                      console.log('there was an error registering for push notifications');
                                      } else {
                                      console.log("Registered with ID: " + event.pushID);
                                      }
                                      }, false);

            /*
             document.addEventListener('urbanairship.push', function(event) {
                                      alert(event.message);
                                      });
            */
            document.addEventListener("urbanairship.push", function (event) {
                                      console.log("Incoming push: " + event.message)
                                      alert( event.message );
                                      }, false);

            // Set tags on a device that you can push to
            /*
            // http://docs.urbanairship.com/connect/connect_audience.html#tags
            PushNotification.setTags(["loves_cats", "shops_for_games"], function () {
                                     PushNotification.getTags(function (obj) {
                                                              obj.tags.forEach(function (tag) {
                                                                               console.log("Tag: " + tag);
                                                                               });
                                                              });
                                     });
            */

            // Set an alias; lets you tie a device to a user in your system
            // http://docs.urbanairship.com/connect/connect_audience.html#aliases
            PushNotification.setAlias( get_unique_id_for_this_device(), function () {
                                      PushNotification.getAlias(function (alias) {
                                                    console.log("The user formerly known as " + alias)
                                                    });
                                      });

            // Check if push is enabled
            PushNotification.isPushEnabled(function (enabled) {
                                           if (enabled) {
                                           console.log("Push is enabled! Fire away!");
                                           }
                                       });
            dalert( "All set");
        }
        else
        {
            dalert( "Push Notifications not found");
        }
    }
    catch(e)
    {
        dalert("Error during setup of Urbanairship"+e.message);
    }
}