// Gets a unique ID for this device
function get_unique_id_for_this_device()
{
	if (typeof device != 'undefined') 
	{
		return device.uuid;
	}
	else
	{
		//derror ( "Unable to get UUID, creating a custom one" );
		if( supports_html5_storage() )
		{
			var deviceid = localStorage.getItem("deviceid");
			
			if( deviceid == null )
			{
				deviceid = create_uuid();
				localStorage.setItem("deviceid", deviceid);
			}
			return deviceid;
		}
		else
		{
			return "unabletocreateid";
		}
	}
}

function supports_html5_storage() {
  try {
    return 'localStorage' in window && window['localStorage'] !== null;
  } catch (e) {
    return false;
  }
}

function create_uuid()
{
	return 'ACDExxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, 
			function(c) 
			{
				var r = Math.random()*16|0, v = c === 'x' ? r : (r&0x3|0x8);
				return v.toString(16);
			}
		);
}